#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SpiceUsr.h"

#define  STRLEN 100

//getfov_c
#define  BCVLEN 5       //max number of FOV bound vectors
#define  ROOM    10


main(int argc, char *argv[]) {


  SpiceDouble             lat;
  SpiceDouble             lon;
  SpiceDouble             radius;
  
  SpiceDouble             phase, incidence, emission;
  
  SpiceDouble             xpoint[3];
  SpiceDouble             xsrfvec[3];
  SpiceDouble             subpoint[3];
  SpiceDouble             subsrfvec[3];

  SpiceDouble             et;
  SpiceDouble             et_start, et_end;
  SpiceDouble             trgepc;
  SpiceChar               utc[STRLEN];
  SpiceChar               trgutc[STRLEN];
  
  SpiceDouble             SC_pos_bd[3];
  SpiceDouble             lt_SC, lt_lunar;


  SpiceChar        shape  [STRLEN];
  SpiceChar        frame  [STRLEN]; //name of frame that FOV/boresight are defined.
  SpiceDouble      bsight [3]; //boresight vector
  SpiceInt         n_bcv; //number of FOV bound vectors
  SpiceDouble      bounds [BCVLEN][3];
  SpiceDouble      bsight_bd [3]; //boresight vector

  SpiceDouble rotate[3][3];

  SpiceBoolean     found;
    
  //instrument NAIF ID
  SpiceInt         instid = -275610; //PLC_UVI_283
  
  if (argc < 2) {
    fprintf(stderr, "Usage: %s kernel ...\n",argv[0]);
    exit(-1);
  }
  
  
  //Ѥkernelɤ߹ߡti2utcȤή㤦ɤǤ褤
  while (argc > 1) {
    furnsh_c (argv[1]);
    fprintf(stderr,"%s is loaded.\n",argv[1]);
    --argc;
    ++argv;
  }
  
  //¬λ٥ȥ
  getfov_c ( instid, BCVLEN, STRLEN, STRLEN,
        shape, frame,  bsight, &n_bcv, bounds );
  
  
  //¬̾ΡʼºݤˤϺɸ̾Ρˤɽ
  fprintf(stderr, "%s\n",frame);
  
  str2et_c("2010-12-05T22:31:00", &et_start);
  str2et_c("2010-12-07T04:15:00", &et_end);
  
  //ͭʻ󤬤ʤƤ⥨顼Ȥʤ
  erract_c ("SET",STRLEN,"IGNORE");
  
  //5ʬߤǷ׻
  for(et=et_start; et<et_end; et+=300.0) {
    
    //߻
    et2utc_c ( et, "ISOC", 0, STRLEN, utc );
    printf("%s\t",utc);
    
    //̾õľ
    subpnt_c ( "Intercept: ellipsoid" ,
            "VENUS",  et,     "IAU_VENUS", "LT+S",
            "PLANET-C", subpoint, &trgepc, subsrfvec );
    
    //ľ֤а٤Ѵ
    reclat_c ( subpoint, &radius, &lon, &lat );
    lon *= dpr_c();
    if (lon < 0) lon += 360.00;
    lat *= dpr_c();
    printf ("%4.2f\t%4.2f\t", lat, lon);
    
    //¬λ٥ȥζ̾Ǥfootprint֤
    pxform_c ( frame,"IAU_VENUS", et, rotate);
    mxv_c (rotate, bsight, bsight_bd);

    sincpt_c ( "Ellipsoid", "VENUS", et, "IAU_VENUS", "LT+S", 
            "PLANET-C",  "IAU_VENUS",   bsight_bd,   xpoint, 
            &trgepc, xsrfvec, &found );
    
    //ĤʤȤ⤢롥Ĥäʲν
    if(found) {
      //trgepcUTCѴɽ
      et2utc_c ( trgepc, "ISOC", 0, STRLEN, trgutc );
      printf("%s\t",trgutc);
      
      //footprint֤а٤Ѵ
      reclat_c ( xpoint, &radius, &lon, &lat );
      lon *= dpr_c();
      if (lon < 0) lon += 360.00; //0-360degɽ
      lat *= dpr_c();
      printf ("%4.2f\t%4.2f\t", lat, lon);
      
      //footprint֤ˤȾᡤ
      ilumin_c ( "Ellipsoid",
              "VENUS", et, "IAU_VENUS", "LT+S",
              "PLANET-C",  xpoint,  &trgepc, xsrfvec,
              &phase, &incidence, &emission);
      phase *= dpr_c();
      incidence *= dpr_c();
      emission *= dpr_c();
      printf ("%4.2f\t%4.2f\t%4.2f", phase, incidence, emission);
      
    }
  printf ("\n");
  }
}
