#define _GNU_SOURCE 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "SpiceUsr.h"
#define  STRLEN 100
#define  ROOM    10

int get_cam_info (  SpiceInt        instid,
                    SpiceDouble     center[2],
                    SpiceDouble     pixels[2] )
{
  
  SpiceDouble      focal_length;
  SpiceDouble      pixel_size;
  
  //Name of the variable whose value is to be returned from the kernel pool.
  SpiceChar        var_name[STRLEN]; 
  SpiceInt         n_return;
  SpiceBoolean     found_center,found_pixel_samples,found_pixel_lines;
  
  sprintf (var_name,"INS%d_CENTER",instid);
  gdpool_c (var_name,0,ROOM,&n_return,center,&found_center);
  
  sprintf (var_name,"INS%d_PIXEL_SAMPLES",instid);
  gdpool_c (var_name,0,ROOM,&n_return,&pixels[0],&found_pixel_samples);
  
  sprintf (var_name,"INS%d_PIXEL_LINES",instid);
  gdpool_c (var_name,0,ROOM,&n_return,&pixels[1],&found_pixel_lines);
  
  //õƤܤ kernel pool ˤʤä饨顼
  if (!found_center||!found_pixel_samples||!found_pixel_lines) return(0);
  
  return(1);
}